'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MatchMediaListener = function (_Component) {
  (0, _inherits3.default)(MatchMediaListener, _Component);

  function MatchMediaListener() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MatchMediaListener);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MatchMediaListener.__proto__ || (0, _getPrototypeOf2.default)(MatchMediaListener)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      matches: window.matchMedia(_this.props.matchQueryString).matches,
      mediaQueryList: window.matchMedia(_this.props.matchQueryString)
    }, _this.listener = function (e) {
      _this.setState({ matches: e.matches });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MatchMediaListener, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var listener = this.listener,
          mediaQueryList = this.state.mediaQueryList;

      if (typeof window !== 'undefined') {
        this.setState({ matches: mediaQueryList.matches });
        mediaQueryList.addListener(listener);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var listener = this.listener,
          mediaQueryList = this.state.mediaQueryList;

      mediaQueryList.removeListener(listener);
    }
  }, {
    key: 'render',
    value: function render() {
      var matches = this.state.matches,
          children = this.props.children;

      return children({ matches: matches });
    }
  }]);
  return MatchMediaListener;
}(_react.Component);

MatchMediaListener.propTypes = {
  matchQueryString: _propTypes2.default.string.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children']));

exports.default = enhance(MatchMediaListener);